package com.hw.admin.model.controller;


import com.alibaba.excel.EasyExcel;
import com.hw.admin.model.domain.AjaxResultVo;
import com.hw.admin.model.domain.WorkPacker;
import com.hw.admin.model.domain.WorkPackerExcel;
import com.hw.admin.model.mapper.WorkPackerMapper;
import com.hw.admin.model.service.WorkPackerService;
import com.hw.admin.system.listener.WorkPackerListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


@RestController
@RequestMapping("/workPacker")
public class WorkPackerController {

    @Autowired
    private WorkPackerService workPackerService;

    @Autowired
    private WorkPackerMapper workPackerMapper;

    @PostMapping
    @ResponseBody
    public AjaxResultVo add(@RequestBody WorkPacker workPacker) {
        // 有个很重要的点 DemoDataListener 不能被spring管理，要每次读取excel都要new,然后里面用到spring可以构造方法传进去
        // 写法3：
        String fileName = "D:\\project\\delivery_project\\远程制药\\后台\\ycpharmacy_excel_service\\excel\\包装机数据测试表.xlsx";
        // 这里 需要指定读用哪个class去读，然后读取第一个sheet 文件流会自动关闭
        EasyExcel.read(fileName, WorkPackerExcel.class, new WorkPackerListener(workPackerMapper)).sheet().doRead();
        //workPackerService.add(workPacker);
        return AjaxResultVo.success();
    }


    @GetMapping("/list")
    @ResponseBody
    public AjaxResultVo list(WorkPacker workPacker) {
        List<WorkPacker> list = workPackerService.list(workPacker);
        return AjaxResultVo.success(list);
    }

    @GetMapping("/{id}")
    @ResponseBody
    public AjaxResultVo get(@PathVariable("id") Long id) {
        return AjaxResultVo.success(workPackerService.get(id));
    }

    @PutMapping
    @ResponseBody
    public AjaxResultVo update(@RequestBody WorkPacker workPacker) {
        return AjaxResultVo.success(workPackerService.update(workPacker));
    }

    /**
     * 批量删除请假业务
     */
    @DeleteMapping("/{id}")
    @ResponseBody
    public AjaxResultVo delete(@PathVariable("id") Long id) {
        return AjaxResultVo.success(workPackerService.delete(id));
    }

    /**
     * 批量删除请假业务
     */
    @DeleteMapping
    @ResponseBody
    public AjaxResultVo deleteByIds(@RequestBody List<Long> ids) {
        return AjaxResultVo.success(workPackerService.deleteByIds(ids));
    }
}
